#ifndef lib_H
#define lib_H
#pragma comment(lib, "pcie_lib_diag.lib")

//#include <stdio.h>
//#include <cstdint>

/************************************************************************************
* 1. Device Open
*		Device_Open();
*		- return  WD_STATUS_SUCCESS is OK else Error
* 2. Device Close
*		Device_Close();
*		- return WD_STATUS_SUCCESS is OK else Error
* 3. Get Data(SD, HD, I2C)
*		1) Get_Frm(&SD, &HD);
*			- member is DOUBLE pointer.
*		2) Get_Status();
*			- return status
*			  if status is STATUS_NULL then no update data
*			  if status include STATUS_SD then SD frm is update
*			  if status include STATUS_HD then HD frm is update
*			  if status include STATUS_I2C then I2C data is update
*		3) Get_I2C_data(&I2C)
*			- member is DOUBLE pointer.
************************************************************************************/



//#define WD_STATUS_SUCCESS				0
//
//#define SD_WIDTH						640
//#define SD_HEIGHT						480
//#define HD_WIDTH						1280
//#define HD_HEIGHT						960
//#define BYTE_SIZE						4
//
//#define I2C_ON							1
//#define I2C_OFF							2
//
//#define STATUS_NULL						0x00
//#define STATUS_SD						0x01
//#define STATUS_HD						0x02
//#define STATUS_I2C						0x04

typedef unsigned long	DWORD;
typedef unsigned char	byte;
typedef UINT64			ulong;
typedef UINT32			u32;
typedef UINT32			uint;

_EXTERN_C
extern DWORD Device_Open(void);
extern DWORD Device_Close(void);
\
extern void Get_Frm(byte **SD_FRM, byte **HD_FRM);
extern void I2C_Switch(INT32 sw);
extern INT32 Get_I2C_data(byte **data);
u32 Get_Status(void);
//u32 Get_FrmData(byte *HD_Frm, byte *SD_Frm, byte *I2C_Frm);

/*********************************************************************************
*	SYS CTRL
*********************************************************************************/
//extern u32 SYS_CTRL_GetOutInfoIntrCnt();
//extern void SYS_CTRL_SetSelDSPSrc(u32 sel);
//extern u32 SYS_CTRL_GetSDFreq();
//extern u32 SYS_CTRL_GetHDFreq();
//extern u32 SYS_CTRL_GetSDActPixCnt();
//extern u32 SYS_CTRL_GetHDActPixCnt();
//extern u32 SYS_CTRL_GetSDFrmDur();
//extern u32 SYS_CTRL_GetHDFrmDur();
//extern void SYS_CTRL_DSPReset();
//extern void SYS_CTRL_WriteReg(ulong offset, uint data);
//extern uint SYS_CTRL_ReadReg(ulong offset);
//extern u32 SYS_CTRL_GetSysVersion();

/*********************************************************************************
*	Gamma
*********************************************************************************/
//extern void GAMMA_Enable();
//extern void GAMMA_Disable();
//extern void GAMMA_RegUpdateEnable();
//extern void GAMMA_RegUpdateDisable();
//extern void GAMMA_BypassEnable();
//extern void GAMMA_BypassDisable();
//extern void GAMMA_TestPatternEnable();
//extern void GAMMA_TestPatternDisable();
//extern void GAMMA_Reset();
//extern void GAMMA_ClearReset();
//extern void GAMMA_AutoSyncReset();
//extern void GAMMA_WriteReg(ulong offset, uint data);
//extern u32 GAMMA_ReadReg(ulong offset);

/*********************************************************************************
*	Reg
*********************************************************************************/
//extern void XReg_WriteReg(ulong offset, uint data);
//extern uint XReg_ReadReg(ulong offset);

/*********************************************************************************
*	SD SDI
*********************************************************************************/
//extern void CTRL_SD_EvenOddSwitch();
//extern void CTRL_SD_GammaOnOff(bool OnOff);
//extern void CTRL_SD_GammaValue(FLOAT val);
//extern u32 CTRL_SD_ReadFrmPtr();
//extern u32 CTRL_SD_ReadFrmCnt();
//extern void CTRL_SD_WriteReg(ulong offset, uint data);
//extern uint CTRL_SD_ReadReg(ulong offset);

/*********************************************************************************
*	HD SDI
*********************************************************************************/
//extern void CTRL_HD_GammaOnOff(bool OnOff);
//extern void CTRL_HD_BlurOnOff(bool OnOff);
//extern void CTRL_HD_GammaValue(FLOAT val);
//extern u32 CTRL_HD_ReadFrmPtr();
//extern u32 CTRL_HD_ReadFrmCnt();
//extern void CTRL_HD_EnableBlur();
//extern void CTRL_HD_EnableShapen();
//extern void CTRL_HD_EnableMedian();
//extern void CTRL_HD_DisableImgFilter();
//extern void CTRL_HD_WriteReg(ulong offset, uint data);
//extern uint CTRL_HD_ReadReg(ulong offset);

_END_EXTERN_C

#endif